[build-system]
requires = ["poetry-core"]
build-backend = "poetry.core.masonry.api"

[tool.poetry]
name = "gitlab-cp"
version = "1.3.4"
description = "GitLab Copy CLI"
authors = ["Pierre Smeyers <pierre.smeyers@gmail.com>"]
license = "LGPL"
readme = "README.md"
packages = [{include = "gitlab_cp"}]

[tool.poetry.scripts]
gitlab-cp = "gitlab_cp.sync:run"

[tool.poetry.dependencies]
python = "^3.11"
python-gitlab = "^4.4.0"
gitpython = "^3.1.43"
requests = "^2.32.3"

[tool.poetry.group.dev.dependencies]
# new development dependencies can be added with 'poetry add -D yyy'
pytest = "^8.0.0"
pytest-cov = "^6.0.0"
pytest-env = "^1.0.0"
mypy = "^1.0.0"
ruff = "^0.9.0"

[tool.pytest.ini_options]
# this project uses "pytest" for unit testing
# see: https://docs.pytest.org/en/6.2.x/customize.html#pyproject-toml
testpaths = [
    "tests",
]

[tool.ruff.lint]
extend-select = ["I"] # isort
ignore = ["F841"]

[tool.ruff.format]
# Like Black, use double quotes for strings.
quote-style = "double"

# Like Black, indent with spaces, rather than tabs.
indent-style = "space"

# Like Black, respect magic trailing commas.
skip-magic-trailing-comma = false

# Like Black, automatically detect the appropriate line ending.
line-ending = "auto"

[tool.mypy]
# this project uses "mypy" as a static type checker
# see: https://mypy.readthedocs.io/en/stable/config_file.html
python_version = "3.12"
warn_return_any = true
warn_unused_configs = true
disallow_untyped_defs = true

[[tool.mypy.overrides]]
# loosen rules for tests
module = "tests.*"
warn_return_any = false
disallow_untyped_defs = false

[tool.pylint.messages_control]
max-line-length = 120
disable = [
  "missing-docstring",
#   "unused-argument",
#   "no-value-for-parameter",
#   "no-member",
#   "no-else-return",
#   "bad-whitespace",
#   "bad-continuation",
#   "line-too-long",
#   "fixme",
#   "protected-access",
   "too-few-public-methods",
#   "unspecified-encoding",
#   "redefined-outer-name"
]
